function RES=resid_v(tv,param,data,varargin)

alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sxh     = param(12);
sgl     = param(13);
sgh     = param(14);
sdl     = param(15);
sdh     = param(16);
spl     = param(17);
sph     = param(18);
coefxl  = param(19);
coefxh  = param(20);
coefc   = param(21);
coefe   = param(22);
accprob = param(23);
gam     = param(24);
spi     = sqrt(pi);
spi3    = spi*spi*spi;

tvh     = data.thvh;
tvl     = data.thvl;
TV4     = data.tv3;
TV3     = data.tv2;
XX      = data.x;
util    = data.u;
if nargin>3
    TV4     = data.tv4d;
    TV3     = data.tv3d;
    XX      = data.xd;
    util    = data.ud;
end 
WX      = data.wx;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;
Fh      = data.fh;
Fl      = data.fl;
nint    = size(w,1);
nint3   = size(INT3,1);

Xl  = XX(:,1);
Xh  = XX(:,2);
E   = XX(:,3);

outl    = 0;
outh    = 0;
for i=1:nint;
    
    yi  = y(i);
    wi  = w(i);
    innerl= 0;
    innerh= 0;
    for j=1:nint3;
        gpl     = ggl+rhol*(Xl+spl*yi)+sgl*INT3(j,2)+sxl*INT3(j,1);
        gph     = ggh+rhoh*(Xh+sph*yi)+sgh*INT3(j,2)+sxh*INT3(j,1);
        gdpl    = gdl+psil*rhol*(Xl+spl*yi)+sdl*INT3(j,3)+psil*sxl*INT3(j,1);
        gdph    = gdh+psih*rhoh*(Xh+sph*yi)+sdh*INT3(j,3)+psih*sxh*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*Xl gdpl-gdl-psil*rhol*Xl];
        nuphh   = [gph-ggh-rhoh*Xh gdph-gdh-psih*rhoh*Xh];
        nuphl   = [gpl-ggh-rhoh*Xh gdpl-gdh-psih*rhoh*Xh];
        nuplh   = [gph-ggl-rhol*Xl gdph-gdl-psil*rhol*Xl];
        %
        % Compute the etas
        %
        L1      = likelihood(nupll,Fl);
        L2      = likelihood(nuphl,Fh);
        etapl   = E.*L1./(E.*L1+(1-E).*L2);

        L1      = likelihood(nuplh,Fl);
        L2      = likelihood(nuphh,Fh);
        etaph   = E.*L1./(E.*L1+(1-E).*L2);

        zxll    = (rhol*Xl+nupll*Kl')*coefxl;
        zxlh    = (rhol*Xl+nuplh*Kl')*coefxl;
       
        zxhl    = (rhoh*Xh+nuphl*Kh')*coefxh;
        zxhh    = (rhoh*Xh+nuphh*Kh')*coefxh;

        zel     = norm_inv(etapl)*coefe;
        zeh     = norm_inv(etaph)*coefe;

        
        Tvl     = makepoly3_vb([zxll,zxhl,zel]);
        Tvl2    = makepoly2_vb([zxll,zxhl]);

        Tvh     = makepoly3_vb([zxlh,zxhh,zeh]);
        Tvh2    = makepoly2_vb([zxlh,zxhh]);

        vtpl                    = exp(Tvl*tv+(1-gam)*gpl);
        vtpl(etapl<accprob)     = exp(Tvl2(etapl<accprob,:)*tvh+(1-gam)*gpl(etapl<accprob));
        vtpl(etapl>(1-accprob)) = exp(Tvl2(etapl>(1-accprob),:)*tvl+(1-gam)*gpl(etapl>(1-accprob)));
        
        vtph                    = exp(Tvh*tv+(1-gam)*gph);
        vtph(etaph<accprob)     = exp(Tvh2(etaph<accprob,:)*tvh+(1-gam)*gph(etaph<accprob));
        vtph(etaph>(1-accprob)) = exp(Tvh2(etaph>(1-accprob),:)*tvl+(1-gam)*gph(etaph>(1-accprob)));
        
        innerl  = innerl+vtpl*wint3(j)/spi3;
        innerh  = innerh+vtph*wint3(j)/spi3;

    end
        outl    = outl+innerl*wi/spi;
        outh    = outh+innerh*wi/spi;
end
tmp                 = -(E.*outl+(1-E).*outh);
rhs                 = (1-beta)/(1-gam)+beta*tmp;
lhs                 =-exp(TV4*tv);
lhs(E<accprob)      = exp(TV3(E<accprob,:)*tvh);
lhs(E>(1-accprob))  = exp(TV3(E>(1-accprob),:)*tvl);
if nargin>3
    RES = 1-rhs./lhs;
else
    RES = TV4'*(WX.*(lhs-rhs));
end
