function res = comput_pdrbayes(param,data,thp)
% Function to compute the price dividend ratio
alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sxh     = param(12);
sgl     = param(13);
sgh     = param(14);
sdl     = param(15);
sdh     = param(16);
spl     = param(17);
sph     = param(18);
coefxl  = param(19);
coefxh  = param(20);
coefc   = param(21);
coefe   = param(22);
accprob = param(23);
gam     = param(24);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

thpl    = data.thpl;
thph    = data.thph;
XX      = data.xpd;
TP4     = data.tpp3d;
y       = data.y1d;
w       = data.w1d;
int3    = data.y3d;
wint3   = data.w3d;
kh      = data.kh;
kl      = data.kl;
fh      = data.fh;
fl      = data.fl;
nint3   = size(int3,1);
nint    = size(w,1);

c       = XX(:,1);
xl      = XX(:,2);
xh      = XX(:,3);
e       = XX(:,4);
Tc      = size(c,1);
HP      = hpmat(Tc,6.25);
hpc     = c-HP\c;


prl      = 0;
prh      = 0;
pgl      = 0;
pgh      = 0;
prgl     = 0;
prgh     = 0;
for i=1:nint;
    
    yi      = y(i);
    wi      = w(i);
    tmprl   = 0;
    tmprh   = 0;
    tmpgl   = 0;
    tmpgh   = 0;
    tmprgl  = 0;
    tmprgh  = 0;
    
    for j=1:nint3;
        gpl     = ggl+rhol*(xl+spl*yi)+sgl*int3(j,2)+sxl*int3(j,1);
        gph     = ggh+rhoh*(xh+sph*yi)+sgh*int3(j,2)+sxh*int3(j,1);
        gdpl    = gdl+psil*rhol*(xl+spl*yi)+sdl*int3(j,3)+psil*sxl*int3(j,1);
        gdph    = gdh+psih*rhoh*(xh+sph*yi)+sdh*int3(j,3)+psih*sxh*int3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*xl gdpl-gdl-psil*rhol*xl];
        nuphh   = [gph-ggh-rhoh*xh gdph-gdh-psih*rhoh*xh];
        nuphl   = [gpl-ggh-rhoh*xh gdpl-gdh-psih*rhoh*xh];
        nuplh   = [gph-ggl-rhol*xl gdph-gdl-psil*rhol*xl];
        %
        % compute the etas
        %
        l1      = likelihood(nupll,fl);
        l2      = likelihood(nuphl,fh);
        etapl   = e.*l1./(e.*l1+(1-e).*l2);
        
        l1      = likelihood(nuplh,fl);
        l2      = likelihood(nuphh,fh);
        etaph   = e.*l1./(e.*l1+(1-e).*l2);
        
        zxll    = coefxl*(rhol*xl+nupll*kl');
        zxlh    = coefxl*(rhol*xl+nuplh*kl');
        
        zxhh    = coefxh*(rhoh*xh+nuphh*kh');
        zxhl    = coefxh*(rhoh*xh+nuphl*kh');
        
        zel     = coefe*norm_inv(etapl);
        zeh     = coefe*norm_inv(etaph);
        
        zch      = coefc*(c+gph);
        zcl      = coefc*(c+gpl);
        
        Tpl     = makepoly3_pb([zxll,zxhl,zel]);
        Tpl2    = makepoly2_pb([zxll,zxhl]);
        
        Tph     = makepoly3_pb([zxlh,zxhh,zeh]);
        Tph2    = makepoly2_pb([zxlh,zxhh]);
        
        prpl                     = exp(Tpl*thp);
        prpl(etapl<accprob)      = exp(Tpl2(etapl<accprob,:)*thph);
        prpl(etapl>(1-accprob))  = exp(Tpl2(etapl>(1-accprob),:)*thpl);
        prpl                     = prpl.*exp(gdpl);
        
        prph                     = exp(Tph*thp);
        prph(etaph<accprob)      = exp(Tph2(etaph<accprob,:)*thph);
        prph(etaph>(1-accprob))  = exp(Tph2(etaph>(1-accprob),:)*thpl);
        prph                     = prph.*exp(gdph);
        
        tmprl   = tmprl+prpl*wint3(j)/spi3;
        tmprh   = tmprh+prph*wint3(j)/spi3;
        tmpgl   = tmpgl+exp(gdpl)*wint3(j)/spi3;
        tmpgh   = tmpgh+exp(gdph)*wint3(j)/spi3;
        tmprgl  = tmprgl+exp(-gdpl).*prpl*wint3(j)/spi3;
        tmprgh  = tmprgh+exp(-gdph).*prph*wint3(j)/spi3;
        
        
    end
    prl      = prl+tmprl*wi/spi;
    prh      = prh+tmprh*wi/spi;
    pgl      = pgl+tmpgl*wi/spi;
    pgh      = pgh+tmpgh*wi/spi;
    prgl     = prgl+tmprgl*wi/spi;
    prgh     = prgh+tmprgh*wi/spi;
    
end
R   = exp(TP4*thp);
ER  = e.*prl+(1-e).*prh;
EG  = e.*pgl+(1-e).*pgh;
ERG = e.*prgl+(1-e).*prgh;

%	P/D	P-d	gamd gamd(No pop correction)
DATA=[
    1977	20.364394	3.013788	0.285037	0.295088
    1978	20.647683	3.027603	-0.052312	-0.041746
    1979	23.054217	3.137849	-0.055215	-0.044150
    1980	26.398923	3.273323	-0.029212	-0.017640
    1981	19.733277	2.982306	0.115336	0.125307
    1982	21.395773	3.063193	-0.002146	0.007416
    1983	29.285149	3.377081	-0.187626	-0.178559
    1984	23.093391	3.139546	0.225569	0.234325
    1985	32.206299	3.472162	-0.166352	-0.157458
    1986	33.049032	3.497992	0.045817	0.054904
    1987	31.120471	3.437866	0.007194	0.016129
    1988	28.177136	3.338511	0.187536	0.196628
    1989	34.871274	3.551663	-0.085944	-0.076497
    1990	25.310041	3.231201	0.138834	0.150065
    1991	41.529239	3.726398	-0.295709	-0.282411
    1992	38.534723	3.651560	0.125366	0.138657
    1993	42.542620	3.750506	-0.020891	-0.007898
    1994	37.668119	3.628814	0.105853	0.117970
    1995	54.721552	4.002258	-0.109061	-0.097240
    1996	58.125992	4.062613	0.094719	0.106377
    1997	75.018931	4.317740	-0.012598	-0.000642
    1998	81.985647	4.406544	0.084674	0.096315
    1999	93.717555	4.540286	0.067338	0.078766
    2000	80.344354	4.386322	0.015865	0.026795
    2001	66.334566	4.194711	0.061442	0.071403
    2002	49.216501	3.896229	0.037260	0.046786
    2003	71.550300	4.270401	-0.113753	-0.104520
    2004	56.796571	4.039476	0.309181	0.318211
    2005	57.719486	4.055595	0.011584	0.020853
    2006	60.122372	4.096382	0.051297	0.060795
    2007	55.189670	4.010776	0.088692	0.098277
    2008	26.636166	3.282270	0.154719	0.164111
    2009	50.782979	3.927561	-0.407598	-0.398781
    2010	53.648111	3.982446	0.080682	0.088896
    2011	46.899961	3.848017	0.078477	0.085766
    ];

gd      = DATA(:,4);
T       = length(DATA);
EPD     = zeros(T,1);
for t=1:T;
    EPD(t)  = ERG(t)*DATA(t,2)-1;
end
EPD     = EPD(1:T-1);   % gives E_t P_{t+1}. Start from 77 as we want as first observation E_77(PD_78)

PD0     = zeros(T,1);
PD1     = zeros(T,1);
EPD0    = zeros(T,1);
EPD1    = zeros(T,1);
PD0(1)  = DATA(1,2);
PD1(1)  = DATA(1,2);

EPD0(1) = DATA(1,2);
EPD1(1) = DATA(1,2);
for t=2:T
    EPD0(t) = R(t)*DATA(t-1,2)-1;
    EPD1(t) = ER(t-1)*exp(-gd(t))*DATA(t-1,2)-1;
    PD0(t)  = R(t)*PD0(t-1)-1;
    PD1(t)  = ER(t-1)*exp(-gd(t))*PD1(t-1)-1;
end
smpl    = 2:T;

res.epd = EPD;
res.pd0 = PD0(smpl);
res.pd1 = PD1(smpl);
res.epd0= EPD0(smpl);
res.epd1= EPD1(smpl);
res.data= DATA(smpl,2);
res.div = cumsum(gd(smpl));
res.gd  = gd(smpl);
res.c   = c(smpl);