function RES=resid_rp(thp,param,data,varargin)

% alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sxh     = param(12);
sgl     = param(13);
sgh     = param(14);
sdl     = param(15);
sdh     = param(16);
spl     = param(17);
sph     = param(18);
coefxl  = param(19);
coefxh  = param(20);
coefc   = param(21);
coefe   = param(22);
accprob = param(23);
gam     = param(24);

spi     = sqrt(pi);
spi3    = spi*spi*spi;


thpl    = data.thpl;
thph    = data.thph;
XX      = data.x;
TP4     = data.tp3;
if nargin>3
    XX      = data.xd;
    TP4     = data.tp3d;
end    
WX      = data.wx;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;
Fh      = data.fh;
Fl      = data.fl;
nint    = size(w,1);
nint3   = size(INT3,1);


Xl  = XX(:,1);
Xh  = XX(:,2);
E   = XX(:,3);

outl    = 0;
outh    = 0;
for i=1:nint;
    
    yi      = y(i);
    wi      = w(i);
    tmpul   = 0;
    tmpuh   = 0;
    for j=1:nint3;
        gpl     = ggl+rhol*(Xl+spl*yi)+sgl*INT3(j,2)+sxl*INT3(j,1);
        gph     = ggh+rhoh*(Xh+sph*yi)+sgh*INT3(j,2)+sxh*INT3(j,1);
        gdpl    = gdl+psil*rhol*(Xl+spl*yi)+sdl*INT3(j,3)+psil*sxl*INT3(j,1);
        gdph    = gdh+psih*rhoh*(Xh+sph*yi)+sdh*INT3(j,3)+psih*sxh*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*Xl gdpl-gdl-psil*rhol*Xl];
        nuphh   = [gph-ggh-rhoh*Xh gdph-gdh-psih*rhoh*Xh];
        nuphl   = [gpl-ggh-rhoh*Xh gdpl-gdh-psih*rhoh*Xh];
        nuplh   = [gph-ggl-rhol*Xl gdph-gdl-psil*rhol*Xl];
        %
        % Compute the etas
        %
        L1      = likelihood(nupll,Fl);
        L2      = likelihood(nuphl,Fh);
        etapl   = E.*L1./(E.*L1+(1-E).*L2);

        L1      = likelihood(nuplh,Fl);
        L2      = likelihood(nuphh,Fh);
        etaph   = E.*L1./(E.*L1+(1-E).*L2);

        zxll    = (rhol*Xl+nupll*Kl')*coefxl;
        zxlh    = (rhol*Xl+nuplh*Kl')*coefxl;
       
        zxhl    = (rhoh*Xh+nuphl*Kh')*coefxh;
        zxhh    = (rhoh*Xh+nuphh*Kh')*coefxh;

        zel     = norm_inv(etapl)*coefe;
        zeh     = norm_inv(etaph)*coefe;
        
        Tpl     = makepoly3_pb([zxll,zxhl,zel]);
        Tpl2    = makepoly2_pb([zxll,zxhl]);

        Tph     = makepoly3_pb([zxlh,zxhh,zeh]);
        Tph2    = makepoly2_pb([zxlh,zxhh]);
        
        RUpl                    = exp(Tpl*thp);
        RUpl(etapl<accprob)     = exp(Tpl2(etapl<accprob,:)*thph);
        RUpl(etapl>(1-accprob)) = exp(Tpl2(etapl>(1-accprob),:)*thpl);
        RUpl                    = RUpl.*exp(gdpl-gam*gpl);
        
        RUph                    = exp(Tph*thp);
        RUph(etaph<accprob)     = exp(Tph2(etaph<accprob,:)*thph);
        RUph(etaph>(1-accprob)) = exp(Tph2(etaph>(1-accprob),:)*thpl);
        RUph                    = RUph.*exp(gdph-gam*gph);
        
        tmpul   = tmpul+RUpl*wint3(j)/spi3;
        tmpuh   = tmpuh+RUph*wint3(j)/spi3;
        
    end
    
    outl    = outl+tmpul*wi/spi;
    outh    = outh+tmpuh*wi/spi;
end
if nargin>4
    res     = (beta*(E.*outl+(1-E).*outh)).^(-1/gam)-1;
    RES = res;
else
    res = beta*(E.*outl+(1-E).*outh)-1;
    RES = TP4'*(WX.*res);
end
