function RES=residh_rp(thp,param,data,varargin)

% alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxh     = param(11);
sgh     = param(12);
sdh     = param(13);
sph     = param(14);
coefxl  = param(15);
coefxh  = param(16);
coefc   = param(17);
gam     = param(18);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

XX      = data.x;
TP      = data.tp;
if nargin>3
    XX      = data.xd;
    TP      = data.tpd;
end
WX      = data.wx;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;

nint    = size(w,1);
nint3   = size(INT3,1);

Xl      = XX(:,1);
Xh      = XX(:,2);

out     = 0;
for i=1:nint;
    
    tmpuh   = 0;
    yi      = y(i);
    wi      = w(i);
    for j=1:nint3;
        gph     = ggh+rhoh*(Xh+sph*yi)+sgh*INT3(j,2)+sxh*INT3(j,1);
        gdph    = gdh+psih*rhoh*(Xh+sph*yi)+sdh*INT3(j,3)+psih*sxh*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nuphh   = [gph-ggh-rhoh*Xh gdph-gdh-psih*rhoh*Xh];
        nuplh   = [gph-ggl-rhol*Xl gdph-gdl-psil*rhol*Xl];
        
        zxlh    = coefxl*(rhol*Xl+nuplh*Kl');
        zxhh    = coefxh*(rhoh*Xh+nuphh*Kh');
               
        Tph     = makepoly2_pb([zxlh zxhh]);
        
        tmpuh   = tmpuh+exp(Tph*thp+gdph-gam*gph)*wint3(j)/spi3;
        
    end
    out     = out+tmpuh*wi/spi;
end

if nargin>4
    RES = beta*out-1;  
else
    RES = TP'*(WX.*(beta*out-1));
end