function RES=residl_rp(thp,param,data,varargin)

% alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sgl     = param(12);
sdl     = param(13);
spl     = param(14);
coefxl  = param(15);
coefxh  = param(16);
coefc   = param(17);
gam     = param(18);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

XX      = data.x;
TP      = data.tp;
if nargin>3
    XX      = data.xd;
    TP      = data.tpd;
end
WX      = data.wx;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;

nint    = size(w,1);
nint3   = size(INT3,1);

Xl      = XX(:,1);
Xh      = XX(:,2);

out     = 0;
for i=1:nint;
    
    tmpul   = 0;
    yi      = y(i);
    wi      = w(i);
    for j=1:nint3;
        gpl     = ggl+rhol*(Xl+spl*yi)+sgl*INT3(j,2)+sxl*INT3(j,1);
        gdpl    = gdl+psil*rhol*(Xl+spl*yi)+sdl*INT3(j,3)+psil*sxl*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*Xl gdpl-gdl-psil*rhol*Xl];
        nuphl   = [gpl-ggh-rhoh*Xh gdpl-gdh-psih*rhoh*Xh];
        
        zxll    = coefxl*(rhol*Xl+nupll*Kl');
        zxhl    = coefxh*(rhoh*Xh+nuphl*Kh');             

        Tpl     = makepoly2_pb([zxll zxhl]);
        
        tmpul   = tmpul+exp(Tpl*thp+gdpl-gam*gpl)*wint3(j)/spi3;
        
    end
    out     = out+tmpul*wi/spi;
end

if nargin>4
    RES = beta*out-1;  
else
    RES = TP'*(WX.*(beta*out-1));
end