function res = comp_rrfp(param,data,thv,thp)

alpha   = param(1);
beta    = param(2);
gam     = param(3);
rho     = param(4);
psi     = param(5);
gbar    = param(6);
gdbar   = param(7);
sx      = param(8);
sg      = param(9);
sd      = param(10);
sp      = param(11);
coefx   = param(12);
coefc   = param(13);
spi     = sqrt(pi);
spi3    = spi*spi*spi;

y       = data.y1d;
wy      = data.w1d;
e       = data.y3d;
we      = data.w3d;
K       = data.k;
nint    = size(y,1);
nint3   = size(e,1);
C       = data.xd(:,1);
tc      = size(C,1);
if tc>3
HP      = hpmat(tc,6.25);
hpc     = C-HP\C;
end
X       = data.xd(:,2);
TP      = data.tpd;
nouter  = 0;
douter  = 0;
ER      = 0;
ER2     = 0;
for i=1:nint;
    inner   = 0;
    Rin     = 0;
    R2in    = 0;
    yi      = y(i);
    wi      = wy(i);
    for j=1:nint3;
        gp      = gbar+rho*(X+sp*yi)+sg*e(j,2)+sx*e(j,1);
        gdp     = gdbar+psi*rho*(X+sp*yi)+sg*e(j,3)+psi*sx*e(j,1);
        nup     = [rho*sp*yi+sg*e(j,2)+sx*e(j,1);psi*rho*sp*yi+sd*e(j,3)+psi*sx*e(j,1)];
        xp      = coefx*(rho*X+K*nup);
        cp      = coefc*(C+gp);
        Tvp     = makepoly_v([cp,xp]);
        Tpp     = makepoly_p([cp,xp]);
        tmp     = exp(Tpp*thp+gdp);
        Rin     = Rin+tmp*we(j)/spi3;
        R2in    = R2in+tmp.*tmp*we(j)/spi3;
        inner   = inner+exp(Tvp*thv)*we(j)/spi3;
    end
    mpj     = exp(-gam*(gbar+rho*(X+sp*yi))+gam*gam*(sg*sg+sx*sx)/2);
    Inner   = exp(-alpha*inner);
    douter  = douter+Inner*wi/spi;
    nouter  = nouter+(Inner.*mpj)*wi/spi;
    ER      = ER+Rin*wi/spi;
    ER2     = ER2+R2in*wi/spi;
end
Rf      = douter./(beta*nouter);
S2R     = ER2-ER.*ER;
EP      = ER-Rf;
res.rf  = Rf;
res.r   = ER;
res.ep  = EP;
res.r0  = exp(TP*thp+gdbar+psi*X);

res.erf = 100*mean(Rf-1);
res.er  = 100*mean(ER-1);
res.s2r = 100*sqrt(S2R);
res.eep = 100*mean(EP);
res.srf = 100*std(Rf);
%
% Price Dividend Ratio
%
% P       = TP*thp;
% res.epd = mean(P);
% res.spd = 100*std(P);

        % if 0 then mean of square root
met_=0; %
        % if 1 then square root of mean
if met_
    tmp1    = mean(S2R);
    tmp2    = mean((Rf-mean(Rf)).*(Rf-mean(Rf)));
    tmp3    = mean((ER-mean(ER)).*(Rf-mean(Rf)));
    res.sep = 100*sqrt(tmp1+tmp2-2*tmp3);
    res.sr  = 100*sqrt(mean(S2R));
else
    tmp1    = S2R;
    tmp2    = (Rf-mean(Rf)).*(Rf-mean(Rf));
    tmp3    = (ER-mean(ER)).*(Rf-mean(Rf));
    res.sep = 100*mean(sqrt(tmp1+tmp2-2*tmp3));
    res.sr  = 100*mean(sqrt(S2R));
end
%
% Correlations
%
tmp     = corrcoef(Rf,X);
res.crfx= tmp(1,2);
tmp     = corrcoef(ER,X);
res.crx = tmp(1,2);
tmp     = corrcoef(EP,X);
res.cepx= tmp(1,2);
if tc>3
tmp     = corrcoef(Rf,hpc);
res.crfc= tmp(1,2);
tmp     = corrcoef(ER,hpc);
res.crc = tmp(1,2);
smpl    = 8:34;
tmp     = corrcoef(EP(smpl),hpc(smpl));
res.cepc= tmp(1,2);
res.hpc = hpc;
end
res.x   = X;
