function [res,thv]=fcalib_alpha(alpha,param,data,bench)
crit    = 1e-6;		                % sum of abs. values small enough to be a solution
delt    = 1e-8;		                % differencing interval for numerical gradient
alp     = 1e-3;		                % tolerance on rate of descent
itmax   = 1000;		                % max no. of iterations
dispo   = 0;                        % partial display
options = [itmax;crit;delt;alp;dispo];

param(1)= alpha;
beta    = param(2);
gam     = param(3);
rho     = param(4);
psi     = param(5);
gbar    = param(6);
sx      = param(8);
sg      = param(9);
sd      = param(10);
sp      = param(11);
coefx   = param(12);
coefc   = param(13);
spi     = sqrt(pi);
spi3    = spi*spi*spi;
load temp2
thv0    = thv;
thv     = fcsolve(@resid_v,thv0,options,param,data);
save temp2 thv
y       = data.y1d;
wy      = data.w1d;
e       = data.y3d;
we      = data.w3d;
K       = data.k;
nint    = size(y,1);
nint3   = size(e,1);
C       = data.xd(:,1);
X       = data.xd(:,2);

nouter  = 0;
douter  = 0;
for i=1:nint;
    inner   = 0;
    yi      = y(i);
    wi      = wy(i);
    for j=1:nint3;
        gp      = gbar+rho*(X+sp*yi)+sg*e(j,2)+sx*e(j,1);
        nup     = [rho*sp*yi+sg*e(j,2)+sx*e(j,1);psi*rho*sp*yi+sd*e(j,3)+psi*sx*e(j,1)];
        xp      = coefx*(rho*X+K*nup);
        cp      = coefc*(C+gp);
        Tvp     = makepoly_v([cp,xp]);
        inner   = inner+exp(Tvp*thv)*we(j)/spi3;
    end
    mpj     = exp(-gam*(gbar+rho*(X+sp*yi))+0.5*gam*gam*(sg*sg+sx*sx));
    Inner   = exp(-alpha*inner);
    douter  = douter+Inner*wi/spi;
    nouter  = nouter+(Inner.*mpj)*wi/spi;
end
Rf      = douter./(beta*nouter);
res     = (100*mean(Rf-1)-bench).^2;