function integ = integ_data(mono)

nint    = 12;               % # order of approximation of the integral
[e,w]   = gauss_herm(nint); % # nodes and weights for Gauss quadrature
e       = e*sqrt(2);
y       = e;

if mono
    d       = 3;
%     r       = sqrt(1+d/2);
    s       = sqrt(0.5+d/4);
    v       = pi^(d/2);
    a       = 2*v/(d+2);
    b       = (4-d)*v/(2*(d+2)*(d+2));
    c       = v/((d+2)*(d+2));
    
    nint3       = 2*d*d+1;
    INT         = zeros(nint3,3);
    WINT        = zeros(nint3,1);
    INT (1,:)   = [0 0 0];
    WINT (1)    = a;
    k=2;
    I       = eye(d)*sqrt(2);
    for i=1:d;
        INT (k,:)= I(i,:);
        INT (k+1,:)= -I(i,:);
        WINT (k:k+1)= b;
        k=k+2;
    end
    I       = s*I;
    for i=1:d-1;
        for j=i+1:d;
            INT(k,:)= I(i,:)+I(j,:);
            INT(k+1,:)= I(i,:)-I(j,:);
            INT(k+2,:)= -I(i,:)+I(j,:);
            INT(k+3,:)= -I(i,:)-I(j,:);
            WINT(k:k+3)= c;
            k=k+4;
        end
    end
else
    nint3   = nint*nint*nint;
    INT     = zeros(nint3,3);
    WINT    = zeros(nint3,1);
    k       = 1;
    for i1=1:nint;
        for i2=1:nint;
            for i3=1:nint;
                WINT(k,:)  = w(i1)*w(i2)*w(i3);
                INT(k,:)   = [e(i1) e(i2) e(i3)];
                k           = k+1;
            end
        end
    end
end
integ.y1d   = y;
integ.w1d   = w;
integ.n1d   = size(y,1);
integ.y3d   = INT;
integ.w3d   = WINT;
integ.n3d   = size(INT,1);
integ.ye    = [kron(y,ones(nint3,1)) kron(ones(nint,1),INT)];