function [x,w,int]=gauss_herm(n,f,varargin);
%
% Compute the roots
%
J = diag(sqrt([1:n-1]),1)+diag(sqrt([1:n-1]),-1);    % Jacobi matrix
x = sort(eig(sparse(J)))/sqrt(2);                    % Compute eigenvalues
%
% Compute the weights imposing that integration is exact for lower order polynomials
%
A       = zeros(n);
A(1,:)	= ones(1,n);
A(2,:)	= 2*x';
f       = 1;
for i=1:n-2;
   A(i+2,:)	= 2*x'.*A(i+1,:)-2*i*A(i,:);
   f        = f*i;
end
f       = f*n*(n-1);
w      = (2^(n-1)*sqrt(pi)*f)./(n*n*A(n,:)'.*A(n,:)');
if nargin>1;
   int=w'*feval(f,x,varargin{:});
end
