function write_poly(file,N,varargin)
if nargin>2
    file1   = strcat(varargin{1},file,'.m');
else
    file1   = strcat(file,'.m');
end
fid     = fopen(file1,'w+');
fprintf(fid,'function T=%s(X)\n',file);
fprintf(fid,'nx = size(X,1);\n');

% Builds Hermite polynomial

nn  = length(N);
nmax= max(N);
for i=1:nn
    p   = N(i);
    fprintf(fid,'X%d  = X(:,%d);\n',i,i);
    fprintf(fid,'H%d0 = 1;\n',i);
    fprintf(fid,'H%d1 = 2*X%d;\n',i,i);
    for j=2:p;
        fprintf(fid,'H%d%d = 2*X%d.*H%d%d-%d*H%d%d;\n',i,j,i,i,j-1,2*(j-1),i,j-2);
    end
end

% Builds polynomial

MAT = zeros(prod(N+1),nn);
for i=1:nn;    
    MAT(:,i)=kron(ones(prod(N(1:(i-1))+1),1),kron((0:N(i))',ones(prod(N(i+1:nn)+1),1)));
end
pn  = prod(N+1);
fprintf(fid,'T = zeros(nx,%d);\n',sum(sum(MAT,2)<=nmax));
k=1;
for i=1:pn
    if sum(MAT(i,:))<=nmax
        str=sprintf('T(:,%d) = ',k);
        for j=1:nn-1;
            str=strcat(str,sprintf('H%d%d.*',j,MAT(i,j)));
        end
        str=strcat(str,sprintf('H%d%d;',nn,MAT(i,nn)));
        fprintf(fid,'%s \n',str);
        k=k+1;
    end
end
fclose(fid);