% function replic_tables;
addpath data
addpath ../method
T0      = 1978;
T1      = 2011;
data_basic;
smpl    = find(DATA(:,1)==T0):find(DATA(:,1)==T1);
lc      = log(DATA(smpl,5));
gc      = DATA(smpl,10);
gd      = DATA(smpl,11);
hpc     = lc-hpfilter(lc,6.25);
xhat    = csvread('data_hat_tilde.csv',1,1);

data_indices;
full    = DATA(:,1);
smpl    = find(full==T0):find(full==T1);
Rdata   = DATA(smpl,2);
Rfdata  = DATA(smpl,3);
PDdata  = DATA(smpl,4);
BLdata  = DATA(smpl,5);
JLdata  = DATA(smpl,6);
MUdata  = DATA(smpl,7);

data_model;
full    = Ym(:,1);
smpl    = find(full==T0):find(full==T1);
Rmodel  = Ym(:,2);
Rfmodel = Ym(:,3);
EPmodel = Ym(:,4);
PDmodel = Ym(:,5);
VRmodel = Ym(:,6);

%% Table 4: Cumulative Autocorrelations
acm = autocorr(Rmodel-Rfmodel,7);
cacm= cumsum(acm.ac);
acd = autocorr(Rdata-Rfdata,7);
cacd= cumsum(acd.ac);
disp(' ')
disp('Results for Table 4')
disp('===================')
disp(' ')
fprintf('Data  & %5.2f & %5.2f & %5.2f & %5.2f & %5.2f \\\\ \n',cacd([1 2 3 5 7]))
fprintf('Model & %5.2f & %5.2f & %5.2f & %5.2f & %5.2f \\\\ \n',cacm([1 2 3 5 7]))
disp(' ')
%% Table 5:
k   = 5;
Y=EPmodel+Rfmodel;
T   = length(PDmodel);
x   = log(PDmodel(1:T-k));
cst = ones(T-k,1);
y   = 0;
for i=0:k-1
    y	= y+log(1+Y(k+1-i:T-i)/100);
end
y=log(1+Y(k+1-i:T-i)/100);

%% Table 6: Autocorrelations Price Dividend Ratio
y    = PDmodel;
acm1 = autocorr(y,4);
acm1 = acm1.ac([1 2 4]);
acm2 = autocorr(log(y),4);
acm2 = acm2.ac([1 2 4]);

y    = PDdata;
acd1 = autocorr(y,4);
acd1 = acd1.ac([1 2 4]);
acd2 = autocorr(log(y),4);
acd2 = acd2.ac([1 2 4]);
disp('Results for Table 6')
disp('===================')
disp(' ')
fprintf('Data  & %5.2f & %5.2f & %5.2f && %5.2f & %5.2f & %5.2f \\\\ \n',acd1,acd2)
fprintf('Model & %5.2f & %5.2f & %5.2f && %5.2f & %5.2f & %5.2f \\\\ \n',acm1,acm2)
disp(' ')
%%
ord = 2;
% Data
R   = log(1+Rdata/100);
PD  = detrend(log(PDdata),ord);
% Model
Rm  = log(1+Rmodel/100); 
PDm = detrend(log(PDmodel),ord);

%% Table 5
strr    = '';
stre    = '';
strc    = '';
strd    = '';
for i=[3 5]
    y   = zeros(T-i,1);
    ym  = zeros(T-i,1);
    cst = ones(T-i,1);
    for k=1:T-i
        y(k)    = sum(R(k+1:k+i));
    end
    cstm= ones(T-i,1);
    for k=1:T-i
        ym(k)    = sum(Rm(k:k+i-1)); % the difference lies in the fact that we have actually R(t+1)
    end
    
    resr    = robust_ols(y,[cst,PD(1:T-i)]);
    resrm   = robust_ols(ym,[cstm,PDm(1:T-i)]);
    strr    = char(strr,sprintf('%d & %6.2f & [%6.2f,%6.2f] & %6.2f \\\\',i,resr.b(2),resr.ci(2,:),resrm.b(2)));
end
disp('Results for Table 5')
disp('===================')
disp('')
disp(strr)
disp(' ')

%% Table 7
strlev  = '';
strlog  = '';
fmt     = '%d & %5.2f & %6.4f &  %5.2f & %6.4f && %5.2f & %6.4f &  %5.2f & %6.4f \\\\';
for i=[1 2 4 8]
    yd      = gd(i+1:end);
    yc      = gc(i+1:end);
    Xd      = zeros(T-i,i+1);
    LXd     = zeros(T-i,i+1);
    Xm      = zeros(T-i,i+1);
    LXm     = zeros(T-i,i+1);
    Xd(:,1) = 1;
    LXd(:,1)= 1;
    Xm(:,1) = 1;
    LXm(:,1)= 1;
    for j=1:i
        Xd(:,j+1)   = PDdata(i+1-j:T-j);
        LXd(:,j+1)  = log(PDdata(i+1-j:T-j));
        Xm(:,j+1)   = PDmodel(i+1-j:T-j);
        LXm(:,j+1)  = log(PDmodel(i+1-j:T-j));
    end
    rescdlev    = robust_ols(yc,Xd);
    rescdlog    = robust_ols(yc,LXd);
    resddlev    = robust_ols(yd,Xd);
    resddlog    = robust_ols(yd,LXd);
    rescmlev    = robust_ols(yc,Xm);
    rescmlog    = robust_ols(yc,LXm);
    resdmlev    = robust_ols(yd,Xm);
    resdmlog    = robust_ols(yd,LXm);
    strlog      = char(strlog,sprintf(fmt,i,resddlog.r2,resddlog.pv,resdmlog.r2,resdmlog.pv,rescdlog.r2,rescdlog.pv,rescmlog.r2,rescmlog.pv));
    strlev      = char(strlev,sprintf(fmt,i,resddlev.r2,resddlev.pv,resdmlev.r2,resdmlev.pv,rescdlev.r2,rescdlev.pv,rescmlev.r2,rescmlev.pv));
end
disp('Results for Table 7')
disp('===================')
disp('')
disp(strlog)
disp(strlev)
disp(' ')
%% Table 8
data_basic;
str = '';
fmt = '%d & %6.4f & %5.2f && %6.4f & %5.2f \\\\';
for i=[1 2 4 8]
    gc=DATA(DATA(:,1)>=(1978-i),10);
    Xc=zeros(T,i+1);
    for l=1:i
        Xc(:,l)=gc(i+1-l:T+i-l);
    end
    Xc(:,i+1)=1;
    yd      = log(PDdata);
    ym      = log(PDmodel);
    resd    = robust_ols(yd,Xc);
    resm    = robust_ols(ym,Xc);
    str     = char(str,sprintf(fmt,i,resd.pv,resd.r2,resm.pv,resm.r2));
end
disp('Results for Table 8')
disp('===================')
disp('')
disp(str)
disp(' ')
%% Table 9
Y=EPmodel;
T=length(Y);
Time=1978:2011;
dates=[1980 1981 1982 1990 1991 2001 2007 2008 2009]; 
dum=zeros(T,1);
for i=1:9
    dum(Time==dates(i))=1;
end
y=Y(2:T);
x=[ones(T-1,1) Y(1:T-1) dum(2:end).*Y(1:T-1)];
res=robust_ols(y,x);
R=[0 1 1];
disp('Results for Table 9')
disp('===================')
disp('')
disp('Equity Premium')
fprintf('& %5.2f & %5.2f & %6.3f & %2d\\%% \\\\\n',[res.b(2)+res.b(3) res.b(2) tdis_prb(res.tb(3),T-3) round(100*(1-tdis_prb(res.tb(3),T-3)))])
fprintf('& {\\scriptsize(%4.2f;%4.2f)} & {\\scriptsize(%4.2f;%4.2f)}  \\\\\n',[sqrt(R*res.vb*R') (R*res.b)/sqrt(R*res.vb*R') res.sb(2) res.tb(2)])

Y=JLdata/mean(JLdata);Y=(Y-mean(Y))/std(Y);
y=Y(2:T);
x=[ones(T-1,1) Y(1:T-1) dum(2:end).*Y(1:T-1)];
res=robust_ols(y,x);
R=[0 1 1];
disp('JLN Index')
fprintf('& %5.2f & %5.2f & %6.3f & %2d\\%% \\\\\n',[res.b(2)+res.b(3) res.b(2) tdis_prb(res.tb(3),T-3) round(100*(1-tdis_prb(res.tb(3),T-3)))])
fprintf('& {\\scriptsize(%4.2f;%4.2f)} & {\\scriptsize(%4.2f;%4.2f)}  \\\\\n',[sqrt(R*res.vb*R') (R*res.b)/sqrt(R*res.vb*R') res.sb(2) res.tb(2)])

data_bayes;
Y=DATA(:,2);
y=Y(2:T);
x=[ones(T-1,1) Y(1:T-1) dum(2:end).*Y(1:T-1)];
res=robust_ols(y,x);
R=[0 1 1];
disp('Equity Premium (Bayesian Model)')
fprintf('& %5.2f & %5.2f & %6.3f & -- \\%% \\\\\n',[res.b(2)+res.b(3) res.b(2) tdis_prb(res.tb(3),T-3)])
fprintf('& {\\scriptsize(%4.2f;%4.2f)} & {\\scriptsize(%4.2f;%4.2f)}  \\\\\n',[sqrt(R*res.vb*R') (R*res.b)/sqrt(R*res.vb*R') res.sb(2) res.tb(2)])
%% end

function res=robust_ols(y,x)
%
% Performs OLS regression with robust std. dev.
%
[T,nx]  = size(x);
b       = x\y;
u       = y-x*b;
s       = weightmat(u,1);
Ix      = chol(x'*x)\eye(nx);
Vb      = s*(Ix*Ix');
Sb      = sqrt(diag(Vb));
Tb      = b./Sb;
Ci      = [b-1.96*Sb b+1.96*Sb];
ym      = y-mean(y);
rsqr1   = u'*u;
rsqr2   = ym'*ym;
r2      = 1.0 - rsqr1/rsqr2; % r-squared
test    = (r2/(nx-1))/((1-r2)/(T-(nx-1)));
pv      = 1-fdis_cdf(test,nx-1,T-(nx-1));


res.b   = b;
res.sb  = Sb;
res.vb  = Vb;
res.tb  = Tb;
res.ci  = Ci;
res.r2  = r2;
res.test= test;
res.pv  = pv;
end

function W=weightmat(X,par_size)
% 
% Computes robust covariance matrix (using prewhitening).
%
% X series (TxN)
% par_size # of lags in the VAR
%
[rx,cx]	= size(X);
MX			= mean(X);
X			= X-kron(ones(rx,1),MX);
Y			= X(par_size+1:rx,:);
Y			= Y-repmat(mean(Y),rx-par_size,1);


XL			= [];
for i=1:par_size
    XL		= [XL X(par_size-i+1:rx-i,:)];
end

SA			= [];
A			= [];
R			= [];

for i=1:cx
    XL			= XL-repmat(mean(XL),rx-par_size,1);
    B		= XL\Y(:,i);
    A		= [A;B'];
    R		= [R Y(:,i)-XL*B];
end


SA=0;
for i=1:par_size
    SA		= SA+A(:,1+(i-1)*cx:i*cx);
end

W			= inv(eye(cx)-SA)*cov(R)*inv(eye(cx)-SA)';
end