function [data,dats,param,paraml,paramh]   = build_params(param1,param2,ncv0)

gam     = param1(1);
rhoh    = param1(2);
rhol    = param1(3);
psi     = param1(4);
beta    = param1(5);

ncv     = param2(1);
nxlv    = param2(2);
nxhv    = param2(3);
nev     = param2(4);
ncr     = param2(5);
nxlr    = param2(6);
nxhr    = param2(7);
ner     = param2(8);
ncp     = param2(9);
nxlp    = param2(10);
nxhp    = param2(11);
nep     = param2(12);

nodesc  = param2(13);
nodesxl = param2(14);
nodesxh = param2(15);
nodese  = param2(16);

nca     = param2(17);
nxla    = param2(18);
nxha    = param2(19);
nea     = param2(20);

%
% Prepare functions that compute polynomials
%
delete('sol_functions/makepoly40_v.m')
delete('sol_functions/makepoly40_r.m')
delete('sol_functions/makepoly40_p.m')
delete('sol_functions/makepoly30_v.m')
delete('sol_functions/makepoly30_r.m')
delete('sol_functions/makepoly30_p.m')
delete('sol_functions/makepoly4_v.m')
delete('sol_functions/makepoly4_r.m')
delete('sol_functions/makepoly4_p.m')
delete('sol_functions/makepoly3_v.m')
delete('sol_functions/makepoly3_r.m')
delete('sol_functions/makepoly3_p.m')
% write_poly('makepoly40_v',[1,3,3,3]);  % Function for V
% write_poly('makepoly40_r',[3,3,3,3]);  % Function for R
% write_poly('makepoly40_p',[3,3,3,3]);  % Function for P
% write_poly('makepoly30_v',[1,3,3]);      % Function for V
% write_poly('makepoly30_r',[3,3,3]);      % Function for R
% write_poly('makepoly30_p',[3,3,3]);      % Function for P
write_poly('makepoly40_v',[ncv0,2,2,2],'sol_functions/');  % Function for V
write_poly('makepoly40_a',[2,2,2,2],'sol_functions/');  % Function for V
write_poly('makepoly40_r',[3,3,3,3],'sol_functions/');  % Function for R
write_poly('makepoly40_p',[3,3,3,3],'sol_functions/');  % Function for P
write_poly('makepoly30_v',[ncv0,2,2],'sol_functions/');      % Function for V
write_poly('makepoly30_a',[2,2,2],'sol_functions/');      % Function for V
write_poly('makepoly30_r',[3,3,3],'sol_functions/');      % Function for R
write_poly('makepoly30_p',[3,3,3],'sol_functions/');      % Function for P
%
% Prepare functions that compute polynomials
%
write_poly('makepoly4_v',[ncv,nxlv,nxhv,nev],'sol_functions/');  % Function for V
write_poly('makepoly4_r',[ncr,nxlr,nxhr,ner],'sol_functions/');  % Function for R
write_poly('makepoly4_p',[ncp,nxlp,nxhp,nep],'sol_functions/');  % Function for P
write_poly('makepoly4_a',[nca,nxla,nxha,nea],'sol_functions/');  % Function for P
write_poly('makepoly3_v',[ncv,nxlv,nxhv],'sol_functions/');      % Function for V
write_poly('makepoly3_r',[ncr,nxlr,nxhr],'sol_functions/');      % Function for R
write_poly('makepoly3_p',[ncp,nxlp,nxhp],'sol_functions/');      % Function for P
write_poly('makepoly3_a',[nca,nxla,nxha],'sol_functions/');      % Function for P
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
%    Algorithm Parameters + Preparation of polynomial and Integration     %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[zc,wc]     = gauss_herm(nodesc);       % Interpolation nodes C
[zxl,wxl]   = gauss_herm(nodesxl);      % Interpolation nodes Xl
[zxh,wxh]   = gauss_herm(nodesxh);      % Interpolation nodes Xh
[ze,we]     = gauss_herm(nodese);       % Interpolation nodes e

tmpc        = kron(zc,ones(nodesxl*nodesxh*nodese,1));
tmpxl       = kron(ones(nodesc,1),kron(zxl,ones(nodesxh*nodese,1)));
tmpxh       = kron(ones(nodesc*nodesxl,1),kron(zxh,ones(nodese,1)));
tmpe        = kron(ones(nodesc*nodesxl*nodesxh,1),ze);

Zmatrix     = [tmpc tmpxl tmpxh tmpe];
clear tmpc tmpxl tmpxh tmpe;

data.tv40   = makepoly40_v(Zmatrix);             % Polynomial for V
data.tr40   = makepoly40_r(Zmatrix);             % Polynomial for R
data.tp40   = makepoly40_p(Zmatrix);             % Polynomial for P
data.ta40   = makepoly40_a(Zmatrix);             % Polynomial for P

data.tv4    = makepoly4_v(Zmatrix);             % Polynomial for V
data.tr4    = makepoly4_r(Zmatrix);             % Polynomial for R
data.tp4    = makepoly4_p(Zmatrix);             % Polynomial for P
data.ta4    = makepoly4_a(Zmatrix);             % Polynomial for P
data.tv3    = makepoly3_v(Zmatrix(:,1:3));      % Polynomial for V
data.tr3    = makepoly3_r(Zmatrix(:,1:3));      % Polynomial for R
data.tp3    = makepoly3_p(Zmatrix(:,1:3));      % Polynomial for P
data.ta3    = makepoly3_a(Zmatrix(:,1:3));      % Polynomial for P

tmpc        = kron(zc,ones(nodesxl*nodesxh,1));
tmpxl       = kron(ones(nodesc,1),kron(zxl,ones(nodesxh,1)));
tmpxh       = kron(ones(nodesc*nodesxl,1),zxh);
Zmatrix     = [tmpc tmpxl tmpxh];
clear tmpc tmpxl tmpxh;

dats.tv0    = makepoly30_v(Zmatrix(:,1:3));      % Polynomial for V
dats.tr0    = makepoly30_r(Zmatrix(:,1:3));      % Polynomial for R
dats.tp0    = makepoly30_p(Zmatrix(:,1:3));      % Polynomial for P
dats.ta0    = makepoly30_a(Zmatrix(:,1:3));      % Polynomial for P

dats.tv     = makepoly3_v(Zmatrix);             % Polynomial for V
dats.tr     = makepoly3_r(Zmatrix);             % Polynomial for R
dats.tp     = makepoly3_p(Zmatrix);             % Polynomial for P
dats.ta     = makepoly3_a(Zmatrix);             % Polynomial for P

dats.wx     = kron(wc,kron(wxl,wxh));           % Integration for residuals
data.wx     = kron(wc,kron(wxl,kron(wxh,we)));  % Integration for residuals
integ       = integ_data(1);                    % Integration wrt shocks
% If parameter=1 -> Mono
% If parameter=0 -> Gauss-Hermite
data.y1d    = integ.y1d;
data.w1d    = integ.w1d;
data.y3d    = integ.y3d;
data.w3d    = integ.w3d;

dats.y1d    = integ.y1d;
dats.w1d    = integ.w1d;
dats.y3d    = integ.y3d;
dats.w3d    = integ.w3d;

accprob     = 0.001;
tmp         = gauss_herm(4);
coefc       = zc(1)/tmp(1);                     % Scaling coefficient for C
zx10        = gauss_herm(10);
coefxl      = 350*zxl(1)/zx10(1);               % Scaling coefficient for X_hat - low rho
coefxh      = 40*zxh(1)/zx10(1);                % Scaling coefficient for X_hat - high rho
coefe       = ze(1)/zx10(1);                    % Scaling coefficient for X_hat - high rho
C           = zc/coefc;                         % Builds C
XL          = zxl/coefxl;                       % Builds X_hat - low rho
XH          = zxh/coefxh;                       % Builds X_hat - high rho
E           = norm_cdf(ze/coefe);               % Builds E

data.x      = [kron(C,ones(nodese*nodesxh*nodesxl,1)) kron(ones(nodesc,1),kron(XL,ones(nodesxl*nodese,1))) kron(ones(nodesc*nodesxl,1),kron(XH,ones(nodese,1))) kron(ones(nodesc*nodesxl*nodesxh,1),E)];
dats.x      = [kron(C,ones(nodesxh*nodesxl,1)) kron(ones(nodesc,1),kron(XL,ones(nodesxh,1))) kron(ones(nodesc*nodesxl,1),XH)];
data.wx     = kron(wc,kron(wxl,kron(wxh,we)));
dats.wx     = kron(wc,kron(wxl,wxh));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
%            Historical Data + Invariant Structural Parameters            %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
psih    = psi;                      % dividend magnification parameter
psil    = psi;                      % dividend magnification parameter
ggl     = 0.01925200;               % Average consumption growth - low rho
ggh     = 0.01925200;               % Average consumption growth - high rho
gdl     = 0.02319300;               % Average dividend growth - low rho
gdh     = 0.02319300;               % Average dividend growth - high rho

if rhoh==0.85
    if psi==3
        if rhol==0.2
            data_psi300_rhol20_rhoh85;
            sgl     = sqrt(0.00050994);
            sgh     = sqrt(0.00025898);
            sdl     = sqrt(0.04484000);
            sdh     = sqrt(0.04755800);
            sxl     = sqrt(0.00054769);
            sxh     = sqrt(0.00051808);
        elseif rhol==0.25
            data_psi300_rhol25_rhoh85;
            sgl     = sqrt(0.00048564);
            sgh     = sqrt(0.00025898);
            sdl     = sqrt(0.04498100);
            sdh     = sqrt(0.04755800);
            sxl     = sqrt(0.00054584);
            sxh     = sqrt(0.00051808);
        elseif rhol==0.35
            data_psi300_rhol35_rhoh85;
            sgl     = sqrt(0.00044483);
            sgh     = sqrt(0.00025898);
            sdl     = sqrt(0.04536700);
            sdh     = sqrt(0.04755800);
            sxl     = sqrt(0.00053322);
            sxh     = sqrt(0.00051808);
        elseif rhol==0.40
            data_psi300_rhol40_rhoh85;
            sgl     = sqrt(0.00042768);
            sgh     = sqrt(0.00025898);
            sdl     = sqrt(0.04560000);
            sdh     = sqrt(0.04755800);
            sxl     = sqrt(0.00052384);
            sxh     = sqrt(0.00051808);
        elseif rhol==0.45
            data_psi300_rhol45_rhoh85;
            sgl     = sqrt(0.00041226);
            sgh     = sqrt(0.00025898);
            sdl     = sqrt(0.04585200);
            sdh     = sqrt(0.04755800);
            sxl     = sqrt(0.00051324);
            sxh     = sqrt(0.00051808);
        else
            data_psi300_rhol30_rhoh85;
            sgl     = sqrt(0.00046405);
            sgh     = sqrt(0.00025898);
            sdl     = sqrt(0.04515900);
            sdh     = sqrt(0.04755800);
            sxl     = sqrt(0.00054077);
            sxh     = sqrt(0.00051808);
        end
    elseif psi==3.5
        if rhoh==0.85
            data_psi350_rhol30_rhoh85;
            sgl     = sqrt(0.00046882);
            sgh     = sqrt(0.00026413);
            sdl     = sqrt(0.04398300);
            sdh     = sqrt(0.04736900);
            sxl     = sqrt(0.00053649);
            sxh     = sqrt(0.00051458);
        elseif rhoh==0.90
            data_psi350_rhol30_rhoh90;
            sgl     = sqrt(0.00046882);
            sgh     = sqrt(0.00020497);
            sdl     = sqrt(0.04398300);
            sdh     = sqrt(0.04728900);
            sxl     = sqrt(0.00053649);
            sxh     = sqrt(0.00058991);
        end        
    elseif psi==2.5
        if rhol==0.3
            data_psi250_rhol30_rhoh85;
            sgl     = sqrt(0.00046659);
            sgh     = sqrt(0.00026453);
            sdl     = sqrt(0.04646400);
            sdh     = sqrt(0.04808400);
            sxl     = sqrt(0.00053700);
            sxh     = sqrt(0.00050760);
        elseif rhol==0.35
            data_psi250_rhol35_rhoh85;
            sgl     = sqrt(0.00044691);
            sgh     = sqrt(0.00026453);
            sdl     = sqrt(0.04659300);
            sdh     = sqrt(0.04808400);
            sxl     = sqrt(0.00052992);
            sxh     = sqrt(0.00050760);
        elseif rhol==0.25
            data_psi250_rhol25_rhoh85;
            sgl     = sqrt(0.00048904);
            sgh     = sqrt(0.00026453);
            sdl     = sqrt(0.04636600);
            sdh     = sqrt(0.04808400);
            sxl     = sqrt(0.00054111);
            sxh     = sqrt(0.00050760);
        end
    end
else
    if rhol==0.2
        data_psi300_rhol20_rhoh90;
        sgl     = sqrt(0.00050994);
        sgh     = sqrt(0.00019836);
        sdl     = sqrt(0.04484000);
        sdh     = sqrt(0.04730800);
        sxl     = sqrt(0.00054769);
        sxh     = sqrt(0.00059686);
    elseif rhol==0.25
        data_psi300_rhol25_rhoh90;
        sgl     = sqrt(0.00048564);
        sgh     = sqrt(0.00019836);
        sdl     = sqrt(0.04498100);
        sdh     = sqrt(0.04730800);
        sxl     = sqrt(0.00054584);
        sxh     = sqrt(0.00059686);
    elseif rhol==0.35
        data_psi300_rhol35_rhoh90;
        sgl     = sqrt(0.00044483);
        sgh     = sqrt(0.00019836);
        sdl     = sqrt(0.04536700);
        sdh     = sqrt(0.04730800);
        sxl     = sqrt(0.00053322);
        sxh     = sqrt(0.00059686);
    else
        data_psi300_rhol30_rhoh90;
        sgl     = sqrt(0.00046405);
        sgh     = sqrt(0.00019836);
        sdl     = sqrt(0.04515900);
        sdh     = sqrt(0.04730800);
        sxl     = sqrt(0.00054077);
        sxh     = sqrt(0.00059686);
    end
end
whole   = 1930:2011;
t0      = 1977;
t1      = 2011;
smpl    = find(whole==t0):find(whole==t1);
Xld     = DATX(smpl,2);
Xhd     = DATX(smpl,3);
Ed      = DATX(smpl,4);  %(Proba of rhol)
Cd      = log(DATX(smpl,5)/10000);
data.xpd= [Cd Xld Xhd Ed];
dats.xpd= [Cd Xld Xhd];
data.xd = [Cd(2:end) Xld(2:end) Xhd(2:end) Ed(2:end)];  % to start in 1978
dats.xd = [Cd(2:end) Xld(2:end) Xhd(2:end)];            % to start in 1978

Zmatrix     = [Cd*coefc Xld*coefxl Xhd*coefxh norm_inv(Ed)*coefe];
data.tpp4d  = makepoly4_p(Zmatrix);                 % Polynomial for P
data.tpp3d  = makepoly3_p(Zmatrix(:,1:3));          % Polynomial for P
dats.tppd   = makepoly3_p(Zmatrix(:,1:3));          % Polynomial for P

data.tv4d   = makepoly4_v(Zmatrix(2:end,:));        % Polynomial for V
data.tr4d   = makepoly4_r(Zmatrix(2:end,:));        % Polynomial for R
data.tp4d   = makepoly4_p(Zmatrix(2:end,:));        % Polynomial for P
data.ta4d   = makepoly4_a(Zmatrix(2:end,:));        % Polynomial for P
data.tv3d   = makepoly3_v(Zmatrix(2:end,1:3));      % Polynomial for V
data.tr3d   = makepoly3_r(Zmatrix(2:end,1:3));      % Polynomial for R
data.tp3d   = makepoly3_p(Zmatrix(2:end,1:3));      % Polynomial for P
data.ta3d   = makepoly3_a(Zmatrix(2:end,1:3));      % Polynomial for P
dats.tvd    = makepoly3_v(Zmatrix(2:end,1:3));      % Polynomial for V
dats.trd    = makepoly3_r(Zmatrix(2:end,1:3));      % Polynomial for R
dats.tpd    = makepoly3_p(Zmatrix(2:end,1:3));      % Polynomial for P
dats.tad    = makepoly3_a(Zmatrix(2:end,1:3));      % Polynomial for P


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
%                            Kalman Filter                                %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Computation of Pl and Fl
%
crit    = 1;
tol     = 1e-12;
P0      = 1;
while crit>tol
    Fl  = [P0+sgl*sgl psil*P0;psil*P0 psil*psil*P0+sdl*sdl];
    IF  = chol(Fl);
    IF  = IF\eye(2);
    IF  = IF*IF';
    Pl  = rhol*rhol*P0-rhol*rhol*P0*P0*([1 psil]*IF*[1 psil]')+sxl*sxl;
    crit= abs(Pl-P0);
    P0  = Pl;
end
spl     = sqrt(Pl);
data.fl = Fl;
data.kl = rhol*Pl*([1 psil]*IF);
dats.kl = rhol*Pl*([1 psil]*IF);
%
% Computation of Ph and Fh
%
crit    = 1;
tol     = 1e-12;
P0      = 1;
while crit>tol
    Fh  = [P0+sgh*sgh psih*P0;psih*P0 psih*psih*P0+sdh*sdh];
    IF  = chol(Fh);
    IF  = IF\eye(2);
    IF  = IF*IF';
    Ph  = rhoh*rhoh*P0-rhoh*rhoh*P0*P0*([1 psih]*IF*[1 psih]')+sxh*sxh;
    crit= abs(Ph-P0);
    P0  = Ph;
end
sph     = sqrt(Ph);
data.fh = Fh;
data.kh = rhoh*Ph*([1 psih]*IF);
dats.kh = rhoh*Ph*([1 psih]*IF);
% [Pl Ph;spl sph]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
%                                Utility                                  %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U4      = exp((1-gam)*data.x(:,1))/(1-gam);
U3      = exp((1-gam)*dats.x(:,1))/(1-gam);
Ud      = exp((1-gam)*data.xd(:,1))/(1-gam);
Umin    = 0;
if gam>1
    CM      = 1.01*data.x(1,1);
    Umin    = abs(exp((1-gam)*CM)/(1-gam));
end
data.umin= Umin;
data.u  = U4+Umin;
data.ud = Ud+Umin;
dats.u  = U3+Umin;
dats.ud = Ud+Umin;
paraml  = [beta rhol rhoh psil psih ggl ggh gdl gdh sxl sgl sdl spl coefxl coefxh coefc gam];
paramh  = [beta rhol rhoh psil psih ggl ggh gdl gdh sxh sgh sdh sph coefxl coefxh coefc gam];
param   = [beta rhol rhoh psil psih ggl ggh gdl gdh sxl sxh sgl sgh sdl sdh spl sph coefxl coefxh coefc coefe accprob gam];
