function res=comp_momx(tv,param,data)

alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sxh     = param(12);
sgl     = param(13);
sgh     = param(14);
sdl     = param(15);
sdh     = param(16);
spl     = param(17);
sph     = param(18);
coefxl  = param(19);
coefxh  = param(20);
coefc   = param(21);
coefe   = param(22);
accprob = param(23);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

tvh     = data.thvh;
tvl     = data.thvl;
XX      = data.xd;
TV4     = data.tv4d;
TV3     = data.tv3d;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;
Fh      = data.fh;
Fl      = data.fl;
nint    = size(w,1);
nint3   = size(INT3,1);

C   = XX(:,1);
Xl  = XX(:,2);
Xh  = XX(:,3);
E   = XX(:,4);

outl    = 0;
outh    = 0;
outlt   = 0;
outht   = 0;
outxlb  = 0;
outxhb  = 0;
outxlt  = 0;
outxht  = 0;
outxlb2 = 0;
outxhb2 = 0;
outxlt2 = 0;
outxht2 = 0;
for i=1:nint;
    
    yi  = y(i);
    wi  = w(i);
    innerl= 0;
    innerh= 0;
    xxl     = Xl+spl*yi;
    xxh     = Xh+sph*yi;
    for j=1:nint3;
        gpl     = ggl+rhol*(Xl+spl*yi)+sgl*INT3(j,2)+sxl*INT3(j,1);
        gph     = ggh+rhoh*(Xh+sph*yi)+sgh*INT3(j,2)+sxh*INT3(j,1);
        gdpl    = gdl+psil*rhol*(Xl+spl*yi)+sdl*INT3(j,3)+psil*sxl*INT3(j,1);
        gdph    = gdh+psih*rhoh*(Xh+sph*yi)+sdh*INT3(j,3)+psih*sxh*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*Xl gdpl-gdl-psil*rhol*Xl];
        nuphh   = [gph-ggh-rhoh*Xh gdph-gdh-psih*rhoh*Xh];
        nuphl   = [gpl-ggh-rhoh*Xh gdpl-gdh-psih*rhoh*Xh];
        nuplh   = [gph-ggl-rhol*Xl gdph-gdl-psil*rhol*Xl];
        %
        % Compute the etas
        %
        L1      = likelihood(nupll,Fl);
        L2      = likelihood(nuphl,Fh);
        etapl   = E.*L1./(E.*L1+(1-E).*L2);
        
        L1      = likelihood(nuplh,Fl);
        L2      = likelihood(nuphh,Fh);
        etaph   = E.*L1./(E.*L1+(1-E).*L2);
        
        zxll    = (rhol*Xl+nupll*Kl')*coefxl;
        zxlh    = (rhol*Xl+nuplh*Kl')*coefxl;
        
        zxhl    = (rhoh*Xh+nuphl*Kh')*coefxh;
        zxhh    = (rhoh*Xh+nuphh*Kh')*coefxh;
        
        zel     = norm_inv(etapl)*coefe;
        zeh     = norm_inv(etaph)*coefe;
        
        zcl     = (C+gpl)*coefc;
        zch     = (C+gph)*coefc;
        
        Tvl     = makepoly4_v([zcl,zxll,zxhl,zel]);
        Tvl2    = makepoly3_v([zcl,zxll,zxhl]);
        
        Tvh     = makepoly4_v([zch,zxlh,zxhh,zeh]);
        Tvh2    = makepoly3_v([zch,zxlh,zxhh]);
        
        vtpl                    = exp(Tvl*tv);
        vtpl(etapl<accprob)     = exp(Tvl2(etapl<accprob,:)*tvh);
        vtpl(etapl>(1-accprob)) = exp(Tvl2(etapl>(1-accprob),:)*tvl);
        
        vtph                    = exp(Tvh*tv);
        vtph(etaph<accprob)     = exp(Tvh2(etaph<accprob,:)*tvh);
        vtph(etaph>(1-accprob)) = exp(Tvh2(etaph>(1-accprob),:)*tvl);
        
        innerl  = innerl+vtpl*wint3(j)/spi3;
        innerh  = innerh+vtph*wint3(j)/spi3;
        
    end
    outl    = outl+exp(-alpha*innerl)*wi/spi;
    outh    = outh+exp(-alpha*innerh)*wi/spi;
    
    outxlb  = outxlb+xxl*wi/spi;
    outxhb  = outxhb+xxh*wi/spi;
    outxlt  = outxlt+exp(-alpha*innerl).*xxl*wi/spi;
    outxht  = outxht+exp(-alpha*innerh).*xxh*wi/spi;
    outlt  = outlt+exp(-alpha*innerl)*wi/spi;
    outht  = outht+exp(-alpha*innerh)*wi/spi;

    outxlb2 = outxlb2+xxl.*xxl*wi/spi;
    outxhb2 = outxhb2+xxh.*xxh*wi/spi;
    outxlt2 = outxlt2+exp(-alpha*innerl).*xxl.*xxl*wi/spi;
    outxht2 = outxht2+exp(-alpha*innerh).*xxh.*xxh*wi/spi;

end
tmp     = E.*outl+(1-E).*outh;
res.flt=outlt/tmp;
res.fht=outht/tmp;
outxlt  = outxlt./tmp;
outxht  = outxht./tmp;
outxlt2 = outxlt2./tmp;
outxht2 = outxht2./tmp;
res.exl = outxlt;
res.exh = outxht;
res.vxl = outxlb2-outxlb.^2;
res.vxh = outxhb2-outxhb.^2;
res.exb = E.*outxlb+(1-E).*outxhb;
res.ext = E.*outxlt+(1-E).*outxht;
res.vxb = E.*outxlb2+(1-E).*outxhb2-res.exb.^2;
res.vxt = E.*outxlt2+(1-E).*outxht2-res.ext.^2;
