function RES=residl_r(thr,param,data,thl,varargin)

alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sgl     = param(12);
sdl     = param(13);
spl     = param(14);
coefxl  = param(15);
coefxh  = param(16);
coefc   = param(17);
gam     = param(18);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

XX      = data.x;
TX      = data.tr;
if nargin>4
    XX      = data.xd;
    TX      = data.trd;
end
WX      = data.wx;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;

nint    = size(w,1);
nint3   = size(INT3,1);

C       = XX(:,1);
Xl      = XX(:,2);
Xh      = XX(:,3);

out     = 0;
PSI     = 0;
for i=1:nint;
    
    innerl  = 0;
    tmpul   = 0;
    yi      = y(i);
    wi      = w(i);
    for j=1:nint3;
        gpl     = ggl+rhol*(Xl+spl*yi)+sgl*INT3(j,2)+sxl*INT3(j,1);
        gdpl    = gdl+psil*rhol*(Xl+spl*yi)+sdl*INT3(j,3)+psil*sxl*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*Xl gdpl-gdl-psil*rhol*Xl];
        nuphl   = [gpl-ggh-rhoh*Xh gdpl-gdh-psih*rhoh*Xh];
        
        zxll    = coefxl*(rhol*Xl+nupll*Kl');
        zxhl    = coefxh*(rhoh*Xh+nuphl*Kh');             
        zc      = coefc*(C+gpl);
        
        Trpl    = makepoly3_r([zc zxll zxhl]);
        Tvpl    = makepoly3_v([zc zxll zxhl]);
        
        innerl  = innerl+exp(Tvpl*thl)*wint3(j)/spi3;        
        tmpul   = tmpul+exp(Trpl*thr-gam*gpl)*wint3(j)/spi3;
        
    end
    tmpxl   = exp(-alpha*innerl);
    PSI     = PSI+tmpxl*wi/spi;
    out     = out+(tmpxl.*tmpul)*wi/spi;
end

if nargin>4
    RES = beta*out./PSI-1;  
else
    RES = TX'*(WX.*(beta*out./PSI-1));
end