function RES=residl_v(thv,param,data,varargin)

alpha   = param(1);
beta    = param(2);
rhol    = param(3);
rhoh    = param(4);
psil    = param(5);
psih    = param(6);
ggl     = param(7);
ggh     = param(8);
gdl     = param(9);
gdh     = param(10);
sxl     = param(11);
sgl     = param(12);
sdl     = param(13);
spl     = param(14);
coefxl  = param(15);
coefxh  = param(16);
coefc   = param(17);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

XX      = data.x;
TV      = data.tv;
util    = data.u;
if nargin>3
    util    = data.ud;
    XX      = data.xd;
    TV      = data.tvd;
end
WCX     = data.wx;
y       = data.y1d;
w       = data.w1d;
INT3    = data.y3d;
wint3   = data.w3d;
Kh      = data.kh;
Kl      = data.kl;

nint    = size(w,1);
nint3   = size(INT3,1);

C   = XX(:,1);
Xl  = XX(:,2);
Xh  = XX(:,3);
out = 0;
for i=1:nint;
    inner   = 0;
    yi      = y(i);
    wi      = w(i);
    for j=1:nint3;
        gpl     = ggl+rhol*(Xl+spl*yi)+sgl*INT3(j,2)+sxl*INT3(j,1);
        gdpl    = gdl+psil*rhol*(Xl+spl*yi)+sdl*INT3(j,3)+psil*sxl*INT3(j,1);
        %
        % nupij: i-> subscript; j->superscript
        %
        nupll   = [gpl-ggl-rhol*Xl gdpl-gdl-psil*rhol*Xl];
        nuphl   = [gpl-ggh-rhoh*Xh gdpl-gdh-psih*rhoh*Xh];
        
        zxll    = coefxl*(rhol*Xl+nupll*Kl');
        zxhl    = coefxh*(rhoh*Xh+nuphl*Kh');
        zc      = coefc*(C+gpl);
        
        Tpl     = makepoly3_v([zc zxll zxhl]);
        
        inner   = inner+exp(Tpl*thv)*wint3(j)/spi3;
    end
    out     = out+exp(-alpha*inner)*wi/spi;
end
rhs = (1-beta)*util-beta*log(out)/alpha;
lhs = exp(TV*thv);

if nargin>3
    RES = 1-rhs./lhs;
else
    RES = TV'*(WCX.*(lhs-rhs));
end
