% Clear and close
close all
clc
clear all
% Load data
load CMTS_2011_data_v5
YR = years;
scale = 100;
% Setup data
y=[RPCCG';RPCDG'];
y=y*scale;
yOrig = y;
%y=y(:,1:48);

% Year starts 21, 30, 39, 48, 54

% Initial values and matrices
mu=mean(y'); %#ok<UDIM>
H=diag(var(y')); %#ok<UDIM>
Q=sqrt(prod(diag(H)));
psi = 3;
Z=[1 psi]';
rho=.9;

options = optimset('fminsearch');
options.Display='off';
y=y';
y = bsxfun(@minus,y,mean(y));
y=y';
p=fminsearch('kf_bivariate_bansalyaron_wraper',log([H(1,1) H(2,2) Q]),options,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
[a,b,c,d]=kf_bivariate_bansalyaron_wraper(p,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));

options = optimset('fminunc');
options.Display='off';
options.LargeScale='off';


rhos = .9:-.05:0;
pfinal = zeros(length(rhos),4,4);
cutoffs = [21, 30, 39, 48, 54];
for j=1:length(cutoffs)
    count=1;
    disp(YR(cutoffs(j)))
    for rho=rhos
        
        y=yOrig;
        y=y';
        y = bsxfun(@minus,y,mean(y));
        y=y';
        y=y(:,1:cutoffs(j));
        
        options = optimset('fminsearch');
        options.Display='off';
        p=fminsearch('kf_bivariate_bansalyaron_wraper',log([H(1,1) H(2,2) Q]),options,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
        
        options = optimset('fminunc');
        options.Display='off';
        options.LargeScale='off';
        p=fminunc('kf_bivariate_bansalyaron_wraper',p,options,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
        pfinal(count,:,j) = [rho exp(p(1:3))/scale^2];
        p_bivarate{count,j}=p; %#ok<*SAGROW>
        Z=[1 psi]';
        
        y=yOrig;
        y=y';
        y = bsxfun(@minus,y,mean(y));
        y=y';
        [LLFs{count,j},afits{count,j},Ps{count,j},LLFs_indiv{count,j}]=kf_bivariate_bansalyaron_wraper(p,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
        
        count=count+1;
    end
end


%%
kIndex = find(rhos>=.85);
jIndex = find(rhos<=.31 & rhos >= 0.19);
for yy = 1:length(cutoffs)
    count = 1;
    for kk=kIndex % High rhos
        for j=jIndex % Low rhos
            x=[LLFs_indiv{j,yy} LLFs_indiv{kk,yy}];
            BB=2;
            % Probabilities
            eta = zeros(size(x,1),2);
            % Initialize at 50%
            eta(1:BB,:) = repmat([.5 .5],BB,1);
            for i=BB:size(x,1);
                eta(i+1,:) = eta(i,:);
                eta(i+1,:) = eta(i+1,:).*exp(x(i,:));
                eta(i+1,:) = eta(i+1,:)/sum(eta(i+1,:));
            end
            
            pout=[p_bivarate{j,yy}' p_bivarate{kk,yy}'];
            pout(1:3,:)=exp(pout(1:3,:))/scale^2;
            versionName = 'Imposed_LongRun_Mean_OOS';
            if psi~=3
                versionName = [versionName '.psi_' num2str(psi)];
            end
            common_name = ['StartYear' num2str(YR(cutoffs(yy))) '_' versionName '.rho'  num2str(rhos(j)) 'vs' num2str(rhos(kk))];
            csvwrite(['PosteriorProbs_' common_name '.csv'],[YR eta(2:size(eta,1),:)])
            csvwrite(['Xhat_' common_name '.csv'],[YR (afits{j,yy}(1:length(afits{j,yy})-1))'/scale (afits{kk,yy}(1:length(afits{kk,yy})-1))'/scale])
            line = cell(6,1);
            line{1} = [',rho=' num2str(rhos(j)) ',rho=' num2str(rhos(kk))];
            y = yOrig;
            y=y(:,1:cutoffs(yy));
            mu = mean(y,2);
            line{2} = ['mu_g,' num2str(mu(1)) ',' num2str(mu(1))];
            line{3} = ['mu_d,' num2str(mu(2)) ',' num2str(mu(2))];
            line{4} = ['sigma2_g,' num2str(pout(1,1)) ',' num2str(pout(1,2))];
            line{5} = ['sigma2_d,' num2str(pout(2,1)) ',' num2str(pout(2,2))];
            line{6} = ['sigma2_x,' num2str(pout(3,1)) ',' num2str(pout(3,2))];
            fid=fopen(['Parameters_' common_name '.csv'],'wt');
            for i=1:6
                fprintf(fid, '%s \n', line{i});
            end
            fclose(fid);
        end
    end
end

zip('CMST_2017_update.zip','*.csv')
delete('*.csv')